#pragma once

// Initial version of FormItSectorMenu retrieved in October 2015 from
// https://doc.qt.io/archives/qq/qq11-piemenu.html

#include "QtPieMenu"

#include "FormItQtComponentsExport.h"

class FormItSectorMenu;

class FORMIT_QT_COMPONENTS_EXPORT FormItPieMenu : public QtPieMenu
{
public:
    FormItPieMenu(QWidget* parent, uint innerRad, uint outerRad);

    void insertItem(QAction *pAction, int index = -1);
    void insertItem(QIcon icon, FormItSectorMenu *item, int index = -1);

    virtual void generateMask(QBitmap *mask) override;
    virtual void paintEvent(QPaintEvent *event) override;
    virtual bool event(QEvent *event) override;
};

class FORMIT_QT_COMPONENTS_EXPORT FormItSectorMenu : public FormItPieMenu
{
public:
    FormItSectorMenu(QWidget *parent, uint innerRad, uint outerRad);

    int indexAt(const QPoint &pos);

protected:
    virtual void generateMask(QBitmap *mask) override;
    virtual void reposition() override;
    virtual void paintEvent(QPaintEvent *event) override;
    int menuDepth() const;

private:
    int m_startAngle;
    int m_arcLength;
    double m_dStartAngleRad, m_dArcLengthRad;
};
