#pragma once

#include "FormItQtComponentsExport.h"
#include <QWidget>

class QFormItAction;
class QToolBar;
class QToolButton;

class FORMIT_QT_COMPONENTS_EXPORT FormItPopupToolbar : public QWidget
{
    Q_OBJECT
public:
    explicit FormItPopupToolbar(QWidget* parent, const QString& labelText, const std::vector<QFormItAction*>& actions);
    
    void mouseMoveEvent(QMouseEvent *_event) override;

    void showEvent(QShowEvent* evt) override;
    void closeEvent(QCloseEvent* evt) override;

    void paintEvent(QPaintEvent* evt) override;

    void showFrom(QToolButton* trigger);
    

protected:
    static FormItPopupToolbar* m_openToolbar;

    QToolBar* m_toolbar = nullptr;

    std::vector<QToolButton*> m_toolButtons;
    QString m_labelText;

    static QToolButton* m_trigger;
    
private slots:
    void actionClicked();

};